Index: issm/trunk/src/m/classes/SMBgemb.m
===================================================================
--- issm/trunk/src/m/classes/SMBgemb.m	(revision 25994)
+++ issm/trunk/src/m/classes/SMBgemb.m	(revision 26744)
@@ -387,4 +259,212 @@
 			fielddisplay(self,'requested_outputs','additional outputs requested');
 
+
+		end % }}}
+		function self = extrude(self,md) % {{{
+
+			self.Ta=project3d(md,'vector',self.Ta,'type','element');
+			self.V=project3d(md,'vector',self.V,'type','element');
+			self.dswrf=project3d(md,'vector',self.dswrf,'type','element');
+			self.dslrf=project3d(md,'vector',self.dslrf,'type','element');
+			self.P=project3d(md,'vector',self.P,'type','element');
+			self.eAir=project3d(md,'vector',self.eAir,'type','element');
+			self.pAir=project3d(md,'vector',self.pAir,'type','element');
+
+			if ~isnan(self.Dzini)
+				self.Dzini=project3d(md,'vector',self.Dzini,'type','element');
+			end
+			if ~isnan(self.Dini)
+				self.Dini=project3d(md,'vector',self.Dini,'type','element');
+			end
+			if ~isnan(self.Reini)
+				self.Reini=project3d(md,'vector',self.Reini,'type','element');
+			end
+			if ~isnan(self.Gdnini)
+				self.Gdnini=project3d(md,'vector',self.Gdnini,'type','element');
+			end
+			if ~isnan(self.Gspini)
+				self.Gspini=project3d(md,'vector',self.Gspini,'type','element');
+			end
+			if ~isnan(self.ECini)
+				self.ECini=project3d(md,'vector',self.ECini,'type','element');
+			end
+			if ~isnan(self.Wini)
+				self.Wini=project3d(md,'vector',self.Wini,'type','element');
+			end
+			if ~isnan(self.Aini)
+				self.Aini=project3d(md,'vector',self.Aini,'type','element');
+			end
+			if ~isnan(self.Adiffini)
+				self.Adiffini=project3d(md,'vector',self.Adiffini,'type','element');
+			end
+			if ~isnan(self.Tini)
+				self.Tini=project3d(md,'vector',self.Tini,'type','element');
+			end
+
+			if ~isnan(self.dswdiffrf)
+				self.dswdiffrf=project3d(md,'vector',self.dswdiffrf,'type','element');
+			end
+			if ~isnan(self.szaValue)
+				self.szaValue=project3d(md,'vector',self.szaValue,'type','element');
+			end
+			if ~isnan(self.cotValue)
+				self.cotValue=project3d(md,'vector',self.cotValue,'type','element');
+			end
+			if ~isnan(self.ccsnowValue)
+				self.ccsnowValue=project3d(md,'vector',self.ccsnowValue,'type','element');
+			end
+			if ~isnan(self.cciceValue)
+				self.cciceValue=project3d(md,'vector',self.cciceValue,'type','element');
+			end
+			if ~isnan(self.aValue)
+				self.aValue=project3d(md,'vector',self.aValue,'type','element');
+			end
+			if ~isnan(self.teValue)
+				self.teValue=project3d(md,'vector',self.teValue,'type','element');
+			end
+
+		end % }}}
+		function list = defaultoutputs(self,md) % {{{
+			list = {'SmbMassBalance','SmbAccumulatedMassBalance'};
+		end % }}}
+		function self = setdefaultparameters(self,mesh,geometry) % {{{
+
+			self.isgraingrowth=1;
+			self.isalbedo=1;
+			self.isshortwave=1;
+			self.isthermal=1;
+			self.isaccumulation=1;
+			self.ismelt=1;
+			self.isdensification=1;
+			self.isturbulentflux=1;
+			self.isconstrainsurfaceT=0;
+			self.isdeltaLWup=0;
+
+			self.aIdx = 1;
+			self.eIdx = 1;
+			self.swIdx = 1;
+			self.denIdx = 2;
+			self.dsnowIdx = 1;
+			self.zTop=10*ones(mesh.numberofelements,1);
+			self.dzTop = .05* ones (mesh.numberofelements,1);
+			self.dzMin = self.dzTop/2;
+			self.InitDensityScaling = 1.0;
+			self.ThermoDeltaTScaling = 1/11;
+
+			self.Vmean=10.0*ones(mesh.numberofelements,1);
+
+			self.zMax=250*ones(mesh.numberofelements,1);
+			self.zMin=130*ones(mesh.numberofelements,1);
+			self.zY = 1.025*ones(mesh.numberofelements,1);
+			self.outputFreq = 30;
+
+			%additional albedo parameters
+			self.aSnow = 0.85;
+			self.aIce = 0.48;
+			self.cldFrac = 0.1;
+			self.t0wet = 15;
+			self.t0dry = 30;
+			self.K = 7;
+			self.adThresh = 1023;
+			self.teThresh = 10;
+
+			self.teValue = ones(mesh.numberofelements,1);
+			self.aValue = self.aSnow*ones(mesh.numberofelements,1);
+			self.dulwrfValue = zeros(mesh.numberofelements,1);
+
+			self.dswdiffrf=0.0*ones(mesh.numberofelements,1);
+			self.szaValue=0.0*ones(mesh.numberofelements,1);
+			self.cotValue=0.0*ones(mesh.numberofelements,1);
+			self.ccsnowValue=0.0*ones(mesh.numberofelements,1);
+			self.cciceValue=0.0*ones(mesh.numberofelements,1);
+
+			self.Dzini=0.05*ones(mesh.numberofelements,2);
+			self.Dini=910.0*ones(mesh.numberofelements,2);
+			self.Reini=2.5*ones(mesh.numberofelements,2);
+			self.Gdnini=0.0*ones(mesh.numberofelements,2);
+			self.Gspini=0.0*ones(mesh.numberofelements,2);
+			self.ECini=0.0*ones(mesh.numberofelements,1);
+			self.Wini=0.0*ones(mesh.numberofelements,2);
+			self.Aini=self.aSnow*ones(mesh.numberofelements,2);
+			self.Adiffini=ones(mesh.numberofelements,2);
+			self.Tini=273.15*ones(mesh.numberofelements,2);
+			% 		/!\ Default value of Tini must be equal to Tmean but don't know Tmean yet (computed when atmospheric forcings are interpolated on mesh).
+			% 		If initialization without restart, this value will be overwritten when snow parameters are retrieved in Element.cpp
+			self.Sizeini=2*ones(mesh.numberofelements,1);
+
+		end % }}}
+		function md = checkconsistency(self,md,solution,analyses) % {{{
+
+			md = checkfield(md,'fieldname','smb.isgraingrowth','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isalbedo','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isshortwave','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isthermal','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isaccumulation','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.ismelt','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isdensification','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isturbulentflux','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isconstrainsurfaceT','values',[0 1]);
+			md = checkfield(md,'fieldname','smb.isdeltaLWup','values',[0 1]);
+
+			md = checkfield(md,'fieldname','smb.Ta','timeseries',1,'NaN',1,'Inf',1,'>',273-100,'<',273+100); %-100/100 celsius min/max value
+			md = checkfield(md,'fieldname','smb.V','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<',45,'size',size(self.Ta)); %max 500 km/h
+			md = checkfield(md,'fieldname','smb.dswrf','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',1400,'size',size(self.Ta));
+			md = checkfield(md,'fieldname','smb.dswdiffrf','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',1400);
+			md = checkfield(md,'fieldname','smb.dlwrf','timeseries',1,'NaN',1,'Inf',1,'>=',0,'size',size(self.Ta));
+			md = checkfield(md,'fieldname','smb.P','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',200,'size',size(self.Ta));
+			md = checkfield(md,'fieldname','smb.eAir','timeseries',1,'NaN',1,'Inf',1,'size',size(self.Ta));
+
+			md = checkfield(md,'fieldname','smb.Tmean','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>',273-100,'<',273+100); %-100/100 celsius min/max value
+			md = checkfield(md,'fieldname','smb.C','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>',0);
+			md = checkfield(md,'fieldname','smb.Vmean','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>=',0);
+			md = checkfield(md,'fieldname','smb.Tz','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>=',0,'<=',5000);
+			md = checkfield(md,'fieldname','smb.Vz','size',[md.mesh.numberofelements 1],'NaN',1,'Inf',1,'>=',0,'<=',5000);
+
+			md = checkfield(md,'fieldname','smb.teValue','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',1);
+			md = checkfield(md,'fieldname','smb.dulwrfValue','timeseries',1,'NaN',1,'Inf',1);
+
+			md = checkfield(md,'fieldname','smb.aIdx','NaN',1,'Inf',1,'values',[0,1,2,3,4]);
+			md = checkfield(md,'fieldname','smb.eIdx','NaN',1,'Inf',1,'values',[0,1,2]);
+			md = checkfield(md,'fieldname','smb.swIdx','NaN',1,'Inf',1,'values',[0,1]);
+			md = checkfield(md,'fieldname','smb.denIdx','NaN',1,'Inf',1,'values',[1,2,3,4,5,6,7]);
+			md = checkfield(md,'fieldname','smb.dsnowIdx','NaN',1,'Inf',1,'values',[0,1,2,3,4]);
+
+			md = checkfield(md,'fieldname','smb.zTop','NaN',1,'Inf',1,'>=',0);
+			md = checkfield(md,'fieldname','smb.dzTop','NaN',1,'Inf',1,'>',0);
+			md = checkfield(md,'fieldname','smb.dzMin','NaN',1,'Inf',1,'>',0);
+			md = checkfield(md,'fieldname','smb.zY','NaN',1,'Inf',1,'>=',1);
+			md = checkfield(md,'fieldname','smb.outputFreq','NaN',1,'Inf',1,'>',0,'<',10*365); %10 years max
+			md = checkfield(md,'fieldname','smb.InitDensityScaling','NaN',1,'Inf',1,'>=',0,'<=',1);
+			md = checkfield(md,'fieldname','smb.ThermoDeltaTScaling','NaN',1,'Inf',1,'>=',0,'<=',1);
+			md = checkfield(md,'fieldname','smb.adThresh','NaN',1,'Inf',1,'>=',0);
+			md = checkfield(md,'fieldname','smb.teThresh','NaN',1,'Inf',1,'>=',0);
+
+			md = checkfield(md,'fieldname','smb.aValue','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',1);
+			switch self.aIdx,
+				case {1 2}
+					md = checkfield(md,'fieldname','smb.aSnow','NaN',1,'Inf',1,'>=',.64,'<=',.89);
+					md = checkfield(md,'fieldname','smb.aIce','NaN',1,'Inf',1,'>=',.27,'<=',.58);
+					if self.aIdx==1
+						md = checkfield(md,'fieldname','smb.szaValue','timeseries',1,'NaN',1,'Inf',1,'>=',0,'<=',90);
+						md = checkfield(md,'fieldname','smb.cotValue','timeseries',1,'NaN',1,'Inf',1,'>=',0);
+						md = checkfield(md,'fieldname','smb.ccsnowValue','timeseries',1,'NaN',1,'Inf',1,'>=',0);
+						md = checkfield(md,'fieldname','smb.cciceValue','timeseries',1,'NaN',1,'Inf',1,'>=',0);
+					end
+				case 3
+					md = checkfield(md,'fieldname','smb.cldFrac','NaN',1,'Inf',1,'>=',0,'<=',1);
+				case 4
+					md = checkfield(md,'fieldname','smb.t0wet','NaN',1,'Inf',1,'>=',15,'<=',21.9);
+					md = checkfield(md,'fieldname','smb.t0dry','NaN',1,'Inf',1,'>=',30,'<=',30);
+					md = checkfield(md,'fieldname','smb.K','NaN',1,'Inf',1,'>=',7,'<=',7);
+			end
+
+			%check zTop is < local thickness:
+			he=sum(md.geometry.thickness(md.mesh.elements),2)/size(md.mesh.elements,2);
+			if any(he<self.zTop),
+				error('SMBgemb consistency check error: zTop should be smaller than local ice thickness');
+			end
+			md = checkfield(md,'fieldname','smb.steps_per_step','>=',1,'numel',[1]);
+			md = checkfield(md,'fieldname','smb.averaging','numel',[1],'values',[0 1 2]);
+			md = checkfield(md,'fieldname','smb.requested_outputs','stringrow',1);
 
 		end % }}}
@@ -403,10 +483,11 @@
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','isdensification','format','Boolean');
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','isturbulentflux','format','Boolean');
-			WriteData(fid,prefix,'object',self,'class','smb','fieldname','isclimatology','format','Boolean');
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','isconstrainsurfaceT','format','Boolean');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','isdeltaLWup','format','Boolean');
 
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','Ta','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','V','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','dswrf','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','dswdiffrf','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','dlwrf','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','P','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
@@ -427,4 +508,5 @@
 
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','aIdx','format','Integer');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','eIdx','format','Integer');
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','swIdx','format','Integer');
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','denIdx','format','Integer');
@@ -440,7 +522,13 @@
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','K','format','Double');
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','adThresh','format','Double');
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','teThresh','format','Double');
 
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','aValue','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','teValue','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','dulwrfValue','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','szaValue','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','cotValue','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','ccsnowValue','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','cciceValue','format','DoubleMat','mattype',2,'timeserieslength',md.mesh.numberofelements+1,'yts',md.constants.yts);
 
 			%snow properties init
@@ -453,4 +541,5 @@
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','Wini','format','DoubleMat','mattype',3);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','Aini','format','DoubleMat','mattype',3);
+			WriteData(fid,prefix,'object',self,'class','smb','fieldname','Adiffini','format','DoubleMat','mattype',3);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','Tini','format','DoubleMat','mattype',3);
 			WriteData(fid,prefix,'object',self,'class','smb','fieldname','Sizeini','format','IntMat','mattype',2);
@@ -466,4 +555,28 @@
 				error('All GEMB forcings (Ta, P, V, dswrf, dlwrf, eAir, pAir) must have the same time steps in the final row!');
 			end
+			if size(md.smb.teValue,2)>1 & any(md.smb.teValue(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing teValue is transient, it must have the same time steps as input Ta in the final row!');
+			end
+			if size(md.smb.dswdiffrf,2)>1 & any(md.smb.dswdiffrf(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing dswdiffrf is transient, it must have the same time steps as input Ta in the final row!');
+			end
+			if size(md.smb.dulwrfValue,2)>1 & any(md.smb.dulwrfValue(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing dulwrfValue is transient, it must have the same time steps as input Ta in the final row!');
+			end
+			if size(md.smb.aValue,2)>1 & any(md.smb.aValue(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing aValue is transient, it must have the same time steps as input Ta in the final row!');
+			end
+			if size(md.smb.szaValue,2)>1 & any(md.smb.szaValue(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing szaValue is transient, it must have the same time steps as input Ta in the final row!');
+			end
+			if size(md.smb.cotValue,2)>1 & any(md.smb.cotValue(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing cotValue is transient, it must have the same time steps as input Ta in the final row!');
+			end
+			if size(md.smb.ccsnowValue,2)>1 & any(md.smb.ccsnowValue(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing ccsnowValue is transient, it must have the same time steps as input Ta in the final row!');
+			end
+			if size(md.smb.cciceValue,2)>1 & any(md.smb.cciceValue(end,:) - md.smb.Ta(end,:) ~= 0)
+				error('If GEMB forcing cciceValue is transient, it must have the same time steps as input Ta in the final row!');
+			end
 			time=self.Ta(end,:); %assume all forcings are on the same time step
 			dtime=diff(time,1);
Index: issm/trunk/src/m/classes/SMBgemb.py
===================================================================
--- issm/trunk/src/m/classes/SMBgemb.py	(revision 25994)
+++ issm/trunk/src/m/classes/SMBgemb.py	(revision 26744)
@@ -8,29 +8,31 @@
 
 class SMBgemb(object):
+    """SMBGEMB class definition
+
+    Usage:
+        SMB = SMBgemb()
     """
-    SMBgemb Class definition
-
-       Usage:
-          SMB = SMBgemb()
-    """
 
     def __init__(self, *args):  # {{{
-        #each one of these properties is a transient forcing to the GEMB model, loaded from meteorological data derived
-        #from an automatic weather stations (AWS). Each property is therefore a matrix, of size (numberofvertices x number
-        #of time steps. )
+        """Each one of these properties is a transient forcing to the GEMB 
+        model, loaded from meteorological data derived from an automatic 
+        weather stations (AWS). Each property is therefore a matrix, of size 
+        (numberofvertices x number of time steps.
+        """
 
         #solution choices
-        #check these:
-        #self.isgraingrowth = 0
-        #self.issmbgradients = 0
-        #isalbedo
-        #isshortwave
-        #isthermal
-        #isaccumulation
-        #ismelt
-        #isdensification
-        #isturbulentflux
-
-        #inputs:
+        self.isgraingrowth = 0
+        self.isalbedo = 0
+        self.isshortwave = 0
+        self.isthermal = 0
+        self.isaccumulation = 0
+        self.ismelt = 0
+        self.isdensification = 0
+        self.isturbulentflux = 0
+        self.isconstrainsurfaceT = 0
+        self.isdeltaLWup = 0
+        self.isclimatology = np.nan
+
+        # Inputs
         self.Ta                     = np.nan    # 2 m air temperature, in Kelvin
         self.V                      = np.nan    # wind speed (m/s-1)
@@ -40,4 +42,5 @@
         self.eAir                   = np.nan    # screen level vapor pressure [Pa]
         self.pAir                   = np.nan    # surface pressure [Pa]
+
         self.Tmean                  = np.nan    # mean annual temperature [K]
         self.Vmean                  = np.nan    # mean annual wind velocity [m s-1]
@@ -46,7 +49,8 @@
         self.Vz                     = np.nan    # height above ground at which wind (V) was sampled [m]
 
-        #optional inputs:
-        self.aValue                 = np.nan    # Albedo forcing at every element.  Used only if aIdx == 0.
-        self.teValue                = np.nan    # Outward longwave radiation thermal emissivity forcing at every element (default in code is 1)
+        # Optional inputs
+        self.aValue                 = np.nan    # Albedo forcing at every element. Used only if aIdx == 0, or density exceeds adThresh.
+        self.teValue                = np.nan    # Outward longwave radiation thermal emissivity forcing at every element (default in code is 1), Used only if eIdx== 0, or effective grain radius exceeds teThresh
+        dulwrfValue                 = np.nan    #Delta with which to perturn the long wave radiation upwards. Use if isdeltaLWup is true
 
         # Initialization of snow properties
@@ -54,40 +58,48 @@
         self.Dini                   = np.nan    # snow density (kg m-3)
         self.Reini                  = np.nan    # effective grain size (mm)
-        self.Gdnini                 = np.nan    # grain dricity (0-1)
+        self.Gdnini                 = np.nan    # grain dendricity (0-1)
         self.Gspini                 = np.nan    # grain sphericity (0-1)
         self.ECini                  = np.nan    # evaporation/condensation (kg m-2)
         self.Wini                   = np.nan    # Water content (kg m-2)
         self.Aini                   = np.nan    # albedo (0-1)
+        self.Adiffini               = np.nan    # albedo, diffusive radiation (0-1)
         self.Tini                   = np.nan    # snow temperature (K)
         self.Sizeini                = np.nan    # Number of layers
 
-        #settings:
+        # Settings
         self.aIdx                   = np.nan    # method for calculating albedo and subsurface absorption (default is 1)
-            # 0: direct input from aValue parameter
-            # 1: effective grain radius [Gardner & Sharp, 2009]
-            # 2: effective grain radius [Brun et al., 1992; LeFebre et al., 2003], with swIdx=1, SW penetration follows grain size in 3 spectral bands (Brun et al., 1992)
-            # 3: density and cloud amount [Greuell & Konzelmann, 1994]
-            # 4: exponential time decay & wetness [Bougamont & Bamber, 2005]
-
-        self.swIdx                  = np.nan    # apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 1, with snow density (taken from Bassford, 2004))
+        # 0: direct input from aValue parameter, no use of adThresh
+        # 1: effective grain radius [Gardner & Sharp, 2009]
+        # 2: effective grain radius [Brun et al., 1992; LeFebre et al., 2003], with swIdx=1, SW penetration follows grain size in 3 spectral bands (Brun et al., 1992)
+        # 3: density and cloud amount [Greuell & Konzelmann, 1994]
+        # 4: exponential time decay & wetness [Bougamont & Bamber, 2005]
+        
+        self.eIdx                   = np.nan    #method for calculating emissivity (default is 1)
+        # 0: direct input from teValue parameter, no use of teThresh
+        # 1: default value of 1, in areas with grain radius below teThresh
+        # 2: default value of 1, in areas with grain radius below teThresh and areas of dry snow (not bare ice or wet) at the surface
+
+        self.swIdx                  = np.nan    # apply all SW to top grid cell (0) or allow SW to penetrate surface (1) (default 1, if aIdx=2 function of effective radius (Brun et al., 1992) or else dependent on snow density (taken from Bassford, 2002))
+
         self.denIdx                 = np.nan    # densification model to use (default is 2):
-            # 1 = emperical model of Herron and Langway (1980)
-            # 2 = semi-emperical model of Anthern et al. (2010)
-            # 3 = DO NOT USE: physical model from Appendix B of Anthern et al. (2010)
-            # 4 = DO NOT USE: emperical model of Li and Zwally (2004)
-            # 5 = DO NOT USE: modified emperical model (4) by Helsen et al. (2008)
-            # 6 = Antarctica semi-emperical model of Ligtenberg et al. (2011)
-            # 7 = Greenland semi-emperical model of Kuipers Munneke et al. (2015)
+        # 1 = emperical model of Herron and Langway (1980)
+        # 2 = semi-emperical model of Anthern et al. (2010)
+        # 3 = DO NOT USE: physical model from Appendix B of Anthern et al. (2010)
+        # 4 = DO NOT USE: emperical model of Li and Zwally (2004)
+        # 5 = DO NOT USE: modified emperical model (4) by Helsen et al. (2008)
+        # 6 = Antarctica semi-emperical model of Ligtenberg et al. (2011)
+        # 7 = Greenland semi-emperical model of Kuipers Munneke et al. (2015)
 
         self.dsnowIdx               = np.nan    # model for fresh snow accumulation density (default is 1):
-            # 0 = Original GEMB value, 150 kg/m^3
-            # 1 = Antarctica value of fresh snow density, 350 kg/m^3
-            # 2 = Greenland value of fresh snow density, 315 kg/m^3, Fausto et al. (2008)
-            # 3 = Antarctica model of Kaspers et al. (2004)
-            # 4 = Greenland model of Kuipers Munneke et al. (2015)
+        # 0 = Original GEMB value, 150 kg/m^3
+        # 1 = Antarctica value of fresh snow density, 350 kg/m^3
+        # 2 = Greenland value of fresh snow density, 315 kg/m^3, Fausto et al. (2018)
+        # 3 = Antarctica model of Kaspers et al. (2004)
+        # 4 = Greenland model of Kuipers Munneke et al. (2015)
 
         self.zTop                   = np.nan    # depth over which grid length is constant at the top of the snopack (default 10) [m]
         self.dzTop                  = np.nan    # initial top vertical grid spacing (default .05) [m]
         self.dzMin                  = np.nan    # initial min vertical allowable grid spacing (default dzMin/2) [m]
+
         self.zY                     = np.nan    # strech grid cells bellow top_z by a [top_dz * y ^ (cells bellow top_z)]
         self.zMax                   = np.nan    # initial max model depth (default is min(thickness, 250)) [m]
@@ -95,6 +107,12 @@
         self.outputFreq             = np.nan    # output frequency in days (default is monthly, 30)
 
-        #specific albedo parameters:
-        #Method 1 and 2:
+        # Specific albedo parameters
+        # Method 1
+        self.dswdiffrf              = np.nan    # downward diffusive shortwave radiation flux [W/m^2]
+        self.szaValue               = np.nan    # Solar Zenith Angle [degree]
+        self.cotValue               = np.nan    # Cloud Optical Thickness
+        self.ccsnowValue            = np.nan    # concentration of light absorbing carbon for snow [ppm1]
+        self.cciceValue             = np.nan    # concentration of light absorbing carbon for ice [ppm1]
+        # Method 1 and 2
         self.aSnow                  = np.nan    # new snow albedo (0.64 - 0.89)
         self.aIce                   = np.nan    # range 0.27-0.58 for old snow
@@ -108,9 +126,12 @@
         # or else apply direct input value from aValue, allowing albedo to be altered.
         # Default value is rho water (1023 kg m-3).
-
-        #densities:
+        teThresh                    = np.nan    #Apply eIdx method to all areas with grain radii below this value,
+        #or else apply direct input value from teValue, allowing emissivity to be altered.
+        #Default value is a effective grain radius of 10 mm.
+
+        # Densities
         self.InitDensityScaling     = np.nan    # initial scaling factor multiplying the density of ice, which describes the density of the snowpack.
 
-        #thermo:
+        # Thermal
         self.ThermoDeltaTScaling    = np.nan    # scaling factor to multiply the thermal diffusion timestep (delta t)
 
@@ -119,5 +140,6 @@
         self.requested_outputs      = []
 
-        #Several fields are missing from the standard GEMB model, which are capture intrinsically by ISSM.
+        #Several fields are missing from the standard GEMB model, which are 
+        #captured intrinsically by ISSM.
         #dateN: that's the last row of the above fields.
         #dt:    included in dateN. Not an input.
@@ -125,11 +147,10 @@
 
         nargin = len(args)
-        if nargin:
-            if nargin == 2:
-                mesh = args[0]
-                geometry = args[1]
-                self.setdefaultparameters(mesh, geometry)
-            else:
-                raise Exception('constructor not supported: need mesh and geometry to set defaults')
+        if nargin == 2:
+            mesh = args[0]
+            geometry = args[1]
+            self.setdefaultparameters(mesh, geometry)
+        else:
+            raise Exception('constructor not supported: need mesh and geometry to set defaults')
         #}}}
 
